<%@ Page language="c#" Codebehind="ApplicationController.cs" Inherits="ASPPlus.ApplicationController" %>
<html>
<head>
<title>MVC avec APS.NET</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link type="text/css" rel="stylesheet" href="css/base.css" />
</head>
<body>

<h1>Exemple d'application en ASP.NET utilisant MVC</h1>

<form id="form" runat="server">

<div style="width:48%;float:left;">
<h2>Clients</h2>
<asp:datagrid id="table_clients" runat="server" AutoGenerateColumns="False"
OnEditCommand="ClientsEditHandler"
OnCancelCommand="ClientsCancelHandler"
OnUpdateCommand="ClientsUpdateHandler"
OnDeleteCommand="ClientsDeleteHandler">
       <Columns>
         <asp:BoundColumn DataField="pkey" HeaderText="Numéro" />
         <asp:BoundColumn DataField="nom" HeaderText="Nom" />
         <asp:BoundColumn DataField="prenom" HeaderText="Prénom" />
        <asp:EditCommandColumn EditText="Editer" ButtonType="PushButton"
            UpdateText="Valider" CancelText="Annuler" HeaderText="Actions"/>
        <asp:ButtonColumn ButtonType="PushButton" Text="Supprimer" HeaderText="Supprimer" CommandName="Delete" />
       </Columns>
</asp:datagrid>

<fieldset>
<legend>Ajouter un client</legend>
<p>Nom:<input id="nom" type="text" runat=server/>
Prénom:<input id="prenom" type="text" runat=server/></p>
<asp:Button style="float:right" runat="server" id="ajouterClient" OnClick="ClientsAddHandler" Text="Ajouter" />
</fieldset>
<h2>Produits</h2>
<asp:datagrid id="table_produits" runat="server" AutoGenerateColumns="False"
OnEditCommand="ProduitsEditHandler"
OnCancelCommand="ProduitsCancelHandler"
OnUpdateCommand="ProduitsUpdateHandler"
OnDeleteCommand="ProduitsDeleteHandler">
       <Columns> 
         <asp:BoundColumn DataField="pkey" HeaderText="Numéro" />
         <asp:BoundColumn DataField="label" HeaderText="Label" />
         <asp:BoundColumn DataField="prix" HeaderText="Prix" />
        <asp:EditCommandColumn EditText="Editer" ButtonType="PushButton"
            UpdateText="Valider" CancelText="Annuler" HeaderText="Actions"/>
        <asp:ButtonColumn ButtonType="PushButton" Text="Supprimer" HeaderText="Supprimer" CommandName="Delete" />
       </Columns>
</asp:datagrid>

<fieldset>
<legend>Ajouter un produit</legend>
<p>Label:<input id="label" type="text" runat=server/>
Prix:<input id="prix" type="text" runat=server/></p>
<asp:Button style="float:right" runat="server" id="ajouterProduit" OnClick="ProduitsAddHandler" Text="Ajouter" />
</fieldset>
</div>

<div style="width:48%;float:right;">
<h2>Commandes</h2>
<asp:datagrid id="table_commandes" runat="server" AutoGenerateColumns="False"
OnEditCommand="CommandesEditHandler"
OnCancelCommand="CommandesCancelHandler"
OnUpdateCommand="CommandesUpdateHandler"
OnDeleteCommand="CommandesDeleteHandler">
       <Columns>
         <asp:BoundColumn DataField="pkey" HeaderText="Numéro" />
         <asp:BoundColumn DataField="client_pkey" HeaderText="Client" />
         <asp:BoundColumn DataField="total" HeaderText="Total" />
        <asp:EditCommandColumn EditText="Editer" ButtonType="PushButton"
            UpdateText="Valider" CancelText="Annuler" HeaderText="Actions"/>
        <asp:ButtonColumn ButtonType="PushButton" Text="Supprimer" HeaderText="Supprimer" CommandName="Delete" />
       </Columns>
</asp:datagrid>

<fieldset>
<legend>Ajouter une commande</legend>
<p>Client:<asp:DropDownList id="list_clients" runat="server" datavaluefield="pkey" datatextfield="nom"/></p>
<asp:Button style="float:right" runat="server" id="ajouterCommande" OnClick="CommandesAddHandler" Text="Ajouter" />
</fieldset>

<h2>Liaison produit et commande</h2>
<asp:datagrid id="table_produit_commande" CaptionText="Produits" caption="My DataGrid" runat="server" AutoGenerateColumns="False"
OnEditCommand="Produit_commandeEditHandler"
OnCancelCommand="Produit_commandeCancelHandler"
OnUpdateCommand="Produit_commandeUpdateHandler"
OnDeleteCommand="Produit_commandeDeleteHandler">
       <Columns>
         <asp:BoundColumn DataField="commande_pkey" HeaderText="Commande" />
         <asp:BoundColumn DataField="produit_pkey" HeaderText="Produit" />
         <asp:BoundColumn DataField="quantite" HeaderText="Quantité" />
        <asp:EditCommandColumn EditText="Editer" ButtonType="PushButton"
            UpdateText="Valider" CancelText="Annuler" HeaderText="Actions"/>
        <asp:ButtonColumn ButtonType="PushButton" Text="Supprimer" HeaderText="Supprimer" CommandName="Delete" />
       </Columns>
</asp:datagrid>

<fieldset>
<legend>Ajouter un produit à une commande</legend>
<p>Commande:<asp:DropDownList id="list_commandes" runat="server" datavaluefield="pkey" datatextfield="pkey" />
Produit:<asp:DropDownList id="list_produits" runat="server" datavaluefield="pkey" datatextfield="label"  />
</p><p>Quantité:<input id="quantite" type="text" runat=server/></p>
<asp:Button style="float:right" runat="server" id="ajouterProduitACommande" OnClick="Produit_commandeAddHandler" Text="Ajouter" />
</fieldset>
</div>

</form>

</body>
</html>